# LaTeX Grammarly

A Grammarly client for LaTeX files. LaTeX Grammarly parses the LaTeX file that it looks like plain text for Grammarly. The corrections suggested by Grammarly are then incorporated into the original LaTeX file. 

LaTeX Grammarly can be used as Qt GUI application or as command-line application.

# Screenshots

![GUI](screenshots/correct.png) 

![TUI](screenshots/tui.png) 

# Usage

The checked LaTeX file has to fulfil the following criteria

* Single, flat file (includes are not parsed)
* No newlines in the middle of sentences (i.e., no hard line breaks). You can use the `fix_linebreaks.py` tool to (heuristically) fix the line breaks.

## GUI

To start the GUI version of LaTeX Grammarly, run
```
python3 latexgrammarly.py --gui <file>
```
or start LaTeX Grammarly from your window manager (instead of your terminal)

The most important shortcuts are:

| Shortcut | Action |
|---------|---------|
| Ctrl+Down | Go to next error  |
| Ctrl+Up | Go to previous error  |
| Ctrl+1 | Replace erroneous word with suggestion 1  |
| ... | ...  |
| Ctrl+9 | Replace erroneous word with suggestion 9  |
| Ctrl+L | Add word to dictionary  |
| Ctrl+S | Save document |
| Ctrl+R | Spell check document |
| Ctrl+P | Settings  |


## Command Line

To start the command-line version of LaTeX Grammarly, run
```
python3 latexgrammarly.py <file>
```

All functions are mapped to single keys. All functions which are currently available are displayed in the user interface. 


# Features 

* Supports LaTeX and plain text
* Works with free and premium account of Grammarly
* Multithreading to speed up checking
* Adding words to dictionary
* Suppressing error categories

# Known issues

* Very important: No new lines within sentences! Line ends = Sentence ends. You can use `fix_linebreaks.py` to (heuristically) remove line breaks within sentences.
* Nested LaTeX commands not supported
* Only limited support for text within LaTeX commands
