import sys
import re

if len(sys.argv) != 2:
    print("Usage: %s <input.tex>" % sys.argv[0])
    sys.exit(0)

lines = open(sys.argv[1]).read().split("\n")

repeat = 1
repeat_count = 0

while repeat > 0 and repeat_count < 10:
    repeat -= 1
    repeat_count += 1

    content = ""
    env = 0

    is_start = False

    for line in lines:
        if "\\begin" in line and "document" in line and not is_start:
            is_start = True

        if not is_start:
            content += line + "\n"
            continue

        ls = line.strip()
        if len(ls) > 1:
            first = ls[0]
            last = ls[-1]
            if first == "%":
                content += line + "\n"
                continue

            env += line.count("\\begin{")
            env -= line.count("\\end{")

            env -= line.count("\\begin{abstract}")
            env += line.count("\\end{abstract}")
            env -= line.count("\\begin{document}")
            env += line.count("\\end{document}")
            env -= line.count("\\begin{enumerate}")
            env += line.count("\\end{enumerate}")


            if env > 0:
                content += line + "\n"
                continue

            if last == "{" or last == "}" or last == "&" or last == "\\" or last == "." or last == "!" or last == "?" or last == ":":
                content += line.lstrip() + "\n"
                continue

            if last.count(" ") == 0 and first == "\\" and "\\item" not in line:
                content += line.lstrip() + "\n"
                continue

            if "%" in line:
                content += line.lstrip() + "\n"
                continue

            if ". " in line and last != ".":
                parts = line.split(". ")
                content += ".\n".join([p.rstrip() for p in parts])
                repeat = 1
                print(line)
                continue

            content += line.rstrip() + " "
        else:
            content += line + "\n"

    content = re.sub(r" +", " ", content)
    lines = content.split("\n")

print(content)
