#!/usr/bin/python3
from grammarly import Grammarly, GrammarlyFilter, GrammarlyInvalidUserException, GrammarlyCaptchaException

import sys
import time
import json
import re
import progressbar
import os
import cookie

import settings


def main():
    global interface
    settings.init()

    settings.show_settings = False

    if len(sys.argv) < 3:
        print("Usage: usermod <add|del> email")
        sys.exit(0)
    
    try:
        with open("settings.json") as s:
            settings.form_data = json.load(s)
    except:
        settings.show_settings = True

    email = sys.argv[2]

    try:
        grammarly = Grammarly(settings.form_data["User"], settings.form_data["Pwd"])

        # try to login via browser cookies
        browser_auth = False
        cj = cookie.load()
        if cj:
            for c in cj:
                if "grammarly" in c.domain:
                    if "grauth" in c.name and len(c.value) > 0:
                        grammarly.set_token(c.value)
                        browser_auth = True
                    if "csrf-token" in c.name:
                        grammarly.set_csrf_token(c.value)

        try:
            grammarly.get_token(not browser_auth)
        except GrammarlyCaptchaException:
            print("Grammarly requires a CAPTCHA :(")
            print("Please enter the values of the cookies from your browser:")
            grammarly.set_token(input("  grauth: ").strip())
            grammarly.set_csrf_token(input("  csrf-token: ").strip())
    except GrammarlyInvalidUserException:
        settings.show_settings = True

    if sys.argv[1] == "add":
        grammarly.add_user(email)
    if sys.argv[1] == "del":
        grammarly.del_user(email)

main()
